# Wallet

## Payin by Wallet

<mark style="color:green;">`POST`</mark> `https://gateway-test.pagsmile.com/trade/pay`

This endpoint allows you to submit a payin by Wallet.

#### Headers

| Name                                            | Type   | Description                                |
| ----------------------------------------------- | ------ | ------------------------------------------ |
| Content-Type<mark style="color:red;">\*</mark>  | string | application/json; chartset=UTF-8           |
| Authorization<mark style="color:red;">\*</mark> | string | Basic Base($app\_*id:$security\_*&#x6B;ey) |

#### Request Body

| Name                                              | Type   | Description                                                                                         |
| ------------------------------------------------- | ------ | --------------------------------------------------------------------------------------------------- |
| app\_id<mark style="color:red;">\*</mark>         | string | <p>created app's id at dashboard</p><p>- Max. 32 chars -</p>                                        |
| out\_trade\_no<mark style="color:red;">\*</mark>  | string | <p>ID given by the merchant in their system<br>- Max. 64 chars - </p>                               |
| timestamp<mark style="color:red;">\*</mark>       | string | <p>yyyy-MM-dd HH:mm:ss<br>- Max. 19 chars -</p>                                                     |
| order\_currency<mark style="color:red;">\*</mark> | string | Fixed value: PEN                                                                                    |
| order\_amount<mark style="color:red;">\*</mark>   | string | <p>payment amount<br>- check <a href="../../../data/payment-method#chile">here</a> for limits -</p> |
| notify\_url<mark style="color:red;">\*</mark>     | string | Where Pagsmile will send notification to                                                            |
| website\_url                                      | string | <p>merchant website URL</p><p>- Max. 128 chars -</p>                                                |
| return\_url                                       | string | Redirect to Merchant's url when user finished checkout                                              |
| buyer\_id<mark style="color:red;">\*</mark>       | string | merchant user's id                                                                                  |
| subject<mark style="color:red;">\*</mark>         | string | <p>payment reason or item title</p><p>- Max. 128 chars -</p>                                        |
| content                                           | string | <p>payment reason detail or item detail</p><p>- Max. 255 chars -</p>                                |
| method<mark style="color:red;">\*</mark>          | string | Fixed value: Wallet                                                                                 |
| channel<mark style="color:red;">\*</mark>         | string | <p>Wallet type<br>- Plin or Yape</p>                                                                |

{% tabs %}
{% tab title="200 submit successfully" %}
{% tabs %}
{% tab title="Plin" %}

```
{
    "code": "10000",
    "msg": "Success",
    "prepay_id":"d0pBL05DU*********INk1nTGIzVmttTT0=-24eB2a5D",
    "trade_no": "2022010110293900083",
    "out_trade_no": "202201010354006",
    "web_url": "",
    "pay_url":"https://checkout.pagsmile.com/checkout?prepay_id=d0pB**********2a5D",
    "trade_status": "PROCESSING",
    "qr_code":"00020101021*********005QUOTA010116304E954"
}
```

{% endtab %}

{% tab title="Yape" %}

```
{
    "code": "10000",
    "msg": "Success",
    "prepay_id":"d0pBL05DU*********INk1nTGIzVmttTT0=-24eB2a5D",
    "trade_no": "2022010110293900083",
    "out_trade_no": "202201010354006",
    "web_url": "",
    "pay_url":"https://checkout.pagsmile.com/checkout?prepay_id=d0pB**********2a5D",
    "trade_status": "PROCESSING",
    "qr_code":"000201**********304FEF4"
}
```

{% endtab %}
{% endtabs %}
{% endtab %}

{% tab title="400 duplicate out\_trade\_no" %}

```
{
    "code": "40002",
    "msg": "Business Failed",
    "sub_code": "duplicate-out_trade_no",
    "sub_msg": "out_trade_no is duplicate"
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
**Payment Tips**

* For wallet Yape and wallet Plin, the mobile user can upload a screenshot of the QR code to pay.
  {% endhint %}

## Example

```
curl --location --request POST 'https://gateway-test.pagsmile.com/trade/pay' \
--header 'Authorization: Basic MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==' \
--header 'Content-Type: application/json' \
--data-raw '{
    * "app_id": "162************38",
    * "out_trade_no": "202201010354006",
    * "method": "Wallet",
    * "channel": "Plin", //Plin or Yape
    * "order_amount": "12.01",
    * "order_currency": "PEN",
    * "subject": "trade pay test",
      "content": "trade pay test conent",
    * "notify_url": "http://merchant/callback/success",
      "return_url": "https://www.merchant.com",
    * "buyer_id": "buyer_0101_0001",
    * "timestamp": "2022-01-01 03:54:01"
      }'
```

{% hint style="info" %}
Note:  **162\*\*\*\*\*\*\*\*\*\*\*\*38** is pagsmile's test app id for sandbox, and **MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==** is authorization token associated with the test app id.&#x20;
{% endhint %}

{% hint style="danger" %}
Please use your own **app\_id** and generate your own **authorization token** when testing.
{% endhint %}
